/* =========================================================================

InDesign ExtendScript

NAME: GuidesAround.js
VERSION: 1.0

AUTHOR: Vitaly Batushev
DATE  : 09.08.2004

DESCRIPTION:    (guides)    
   ,   .
        ,   
     .
       .

SUPPORT: http://indesign.rudtp.ru
E-MAIL: vbatushev@indesign.rudtp.ru

============================================================================ */
var ScriptName = app.activeScript.name.substr(0, app.activeScript.name.length - 3);

//=== Language Default ====================================================	
		var strNoOpenDocument = "No open documents";
		var strGeometric = "Geometric bounds"
		var strVisual = "Visual bounds";
		var strPage = "Page bounds"
		var strMargin = "Margin bounds";
		
		var strUse = "Use:";
		var strTop = "Top:";
		var strBottom = "Bottom:";
		var strLeft = "Left:";
		var strRight = "Right:   ";
		var strRemoveOldGuides = "Remove old guides";
//=== End Language Default ====================================================	

	var myIniFile = new File (app.activeScript.path + "/" + ScriptName + ".ini");
	if (!myIniFile.exists) {
		crtini = CreateINI();
		eval ("//@include \'" + ScriptName + ".ini\';");
	} else {
		eval ("//@include \'" + ScriptName + ".ini\';");
	}
	var myLangFile = new File (app.activeScript.path + "/" + iniLangFile);
	if (!myLangFile.exists) {
	} else {
		eval ("//@include \'" + iniLangFile + "\';");
	}

with (app) {
	
	if (documents.length < 1) {
		alert(strNoOpenDocument);
		exit();
	}
	
	var ItsPage = false;
	if (selection.length < 1){
		strGeometric = strPage;
		strVisual = strMargin;
		ItsPage = true;	
	}
	
	var myDlg = dialogs.add({name: ScriptName + " v." + iniScriptVersion})
	with (myDlg) {
		with(dialogColumns.add()) {
			with (borderPanels.add()) {
				staticTexts.add({staticLabel:strUse});
				var rbBoundsSet = radiobuttonGroups.add();
				rbBoundsSet.radiobuttonControls.add({staticLabel:strGeometric});
				rbBoundsSet.radiobuttonControls.add({staticLabel:strVisual});
				rbBoundsSet.selectedButton = iniUseBounds;
			}
			with (borderPanels.add()) {
				with(dialogColumns.add()) {
					with(dialogRows.add()) {
						staticTexts.add({staticLabel:strTop});
						var myTop = realEditboxes.add({editValue:iniTop, minWidth:40});
						staticTexts.add({staticLabel:strBottom});
						var myBottom = realEditboxes.add({editValue:iniBottom, minWidth:40});
					}
					with(dialogRows.add()) {
						staticTexts.add({staticLabel:strLeft});
						var myLeft = realEditboxes.add({editValue:iniLeft, minWidth:40});
						staticTexts.add({staticLabel:strRight});
						var myRight = realEditboxes.add({editValue:iniRight, minWidth:40});	
					}
				}
			}
				var chkRemoveOldGuides = checkboxControls.add({staticLabel:strRemoveOldGuides, checkedState:iniRemoveOldGuides});
				staticTexts.add({staticLabel:"Vitaly Batushev | indesign.rudtp.ru"});
		}
	}
	result = myDlg.show();
	
	if(result == true) {
		
		switch (selection.constructor.name) {
			case "Text":
			case "InsertionPoint":
				exit();
		}
		
		SaveINI(rbBoundsSet.selectedButton, myTop.editValue, myBottom.editValue, myLeft.editValue, myRight.editValue, chkRemoveOldGuides.checkedState);
		
		if (chkRemoveOldGuides.checkedState == true) {
			var curParent = activeWindow.activePage;
			if (selection.length > 1) {
				var FstID = selection[0].parent.id;
				for (i = 1; i < selection.length; i++) {
					if (selection[i].parent.id != FstID) {
						var curParent = activeWindow.activeSpread;
						break;
					}
				}
			}
			if (curParent.guides.length > 0) {
			do {
				curParent.guides[0].remove();
			}
			while (curParent.guides.length > 0); 
			}
		}
		
		if (selection.length < 1){
			var mySelection = activeWindow.activePage;
			DrawGuides(mySelection, rbBoundsSet.selectedButton, myTop.editValue, myBottom.editValue, myLeft.editValue, myRight.editValue);
		} else {
			for (i = 0; i < selection.length; i++) {
				var mySelection = selection[i];
				DrawGuides(mySelection, rbBoundsSet.selectedButton, myTop.editValue, myBottom.editValue, myLeft.editValue, myRight.editValue);
			}
		}
	} else {
		myDlg.destroy();
		exit();
	}	
}

function DrawGuides(myObject, boundsValue, mTop, mBottom, mLeft, mRight) {
	var myBounds = new Array();
	if(boundsValue == 0) {
		if (myObject.constructor.name == 'Page') {
			var myBounds  = myObject.bounds;
		} else {
			var myBounds  = myObject.geometricBounds;
		}
	} else {
		if (myObject.constructor.name == 'Page') {
			var myBounds  = myObject.bounds;
			var myMP = myObject.marginPreferences;
			mTop = mTop - myMP.top;
			mBottom = mBottom - myMP.bottom;
			mLeft = mLeft - myMP.left;
			mRight = mRight - myMP.right;
		} else {
			var myBounds  = myObject.visibleBounds;
		}
	}
	var myParent = myObject.parent;
	
	var TopGuide = myParent.guides.add();
	TopGuide.orientation = HorizontalOrVertical.horizontal;
	TopGuide.color = app.activeWindow.activeLayer.color;
	TopGuide.fitToPage = true;
	TopGuide.location = myBounds[0] - mTop;

	var BottomGuide = myParent.guides.add();
	BottomGuide.orientation = HorizontalOrVertical.horizontal;
	BottomGuide.color = app.activeWindow.activeLayer.color;
	BottomGuide.fitToPage = true;
	BottomGuide.location = myBounds[2] + mBottom;

	var LeftGuide = myParent.guides.add();
	LeftGuide.orientation = HorizontalOrVertical.vertical;
	LeftGuide.color = app.activeWindow.activeLayer.color;
	LeftGuide.fitToPage = true;
	LeftGuide.location = myBounds[1] - mLeft;

	var RightGuide = myParent.guides.add();
	RightGuide.orientation = HorizontalOrVertical.vertical;
	RightGuide.color = app.activeWindow.activeLayer.color;
	RightGuide.fitToPage = true;
	RightGuide.location = myBounds[3] + mRight;
}
function CreateINI() {	
	var nScriptName = app.activeScript.name.substr(0, app.activeScript.name.length - 3);
	var myNewINIfile = new File (app.activeScript.path + "/" + nScriptName + ".ini");
	myNewINIfile.open("w");
	var myINI = "var iniScriptName = \"" + nScriptName + "\";\n";
	myINI = myINI + "var iniScriptVersion = \"1.0\";\n";
	myINI = myINI + "var iniLangFile = \"" + nScriptName + ".ru.slang" + "\";\n";
	myINI = myINI + "var iniUseBounds = 0;\n";
	myINI = myINI + "var iniTop = 0;\n";
	myINI = myINI + "var iniBottom = 0;\n";
	myINI = myINI + "var iniLeft = 0;\n";
	myINI = myINI + "var iniRight = 0;\n";
	myINI = myINI + "var iniRemoveOldGuides = false;\n";
	myNewINIfile.write(myINI);
	myNewINIfile.close();	
	myINI = undefined;
	return CreateINI;
}
function SaveINI(valUseBounds, valTop, valBottom, valLeft, valRight, valRemove) {	
	var nScriptName = app.activeScript.name.substr(0, app.activeScript.name.length - 3);
	var mySaveINIfile = new File (app.activeScript.path + "/" + nScriptName + ".ini");
	mySaveINIfile.open("w");
	var myINI = "var iniScriptName = \"" + nScriptName + "\";\n";
	myINI = myINI + "var iniScriptVersion = \"1.0\";\n";
	myINI = myINI + "var iniLangFile = \"" + iniLangFile + "\";\n";
	myINI = myINI + "var iniUseBounds = " + valUseBounds + ";\n";
	myINI = myINI + "var iniTop = " + valTop + ";\n";
	myINI = myINI + "var iniBottom = " + valBottom + ";\n";
	myINI = myINI + "var iniLeft = " + valLeft + ";\n";
	myINI = myINI + "var iniRight = " + valRight + ";\n";
	myINI = myINI + "var iniRemoveOldGuides = " + valRemove + ";\n";
	mySaveINIfile.write(myINI);
	mySaveINIfile.close();
	myINI = undefined;
	return SaveINI;
}